export declare enum TextOpType {
    insert = "insert",
    delete = "delete",
    retain = "retain"
}
export default class TextOp {
    type: 'insert' | 'delete' | 'retain';
    chars: number | null;
    text: string | null;
    attributes: Record<string, any>;
    constructor(type: TextOp['type'], ...args: any);
    isInsert(): boolean;
    isDelete(): boolean;
    isRetain(): boolean;
    equals(other: TextOp): boolean;
    attributesEqual(otherAttributes: TextOp['attributes']): boolean;
    hasEmptyAttributes(): boolean;
}
