import TextOp from './TextOp';
export default class TextOperation {
    ops: TextOp[];
    baseLength: number;
    targetLength: number;
    meta?: Record<string, any>;
    constructor();
    equals(other: TextOperation): boolean;
    retain(n: number, attributes?: {}): this;
    insert(str: string, attributes?: {}): this;
    delete(n: number | string): this;
    isNoop(): boolean;
    clone(): TextOperation;
    toString(): string;
    toJSON(): (string | number | Record<string, any> | null)[];
    static fromJSON(ops: (number | string | object | null)[]): TextOperation;
    apply(str: string, oldAttributes?: TextOp['attributes'][], newAttributes?: TextOp['attributes'][]): string;
    invert(str: string): TextOperation;
    compose(operation2: TextOperation): TextOperation;
    static getSimpleOp(operation: TextOperation): TextOp | null;
    static getStartIndex(operation: TextOperation): number;
    shouldBeComposedWith(other: TextOperation): boolean;
    shouldBeComposedWithInverted(other: TextOperation): boolean;
    static transformAttributes(attributes1: TextOp['attributes'], attributes2: TextOp['attributes']): Record<string, any>[];
    static transform(operation1: TextOperation, operation2: TextOperation): TextOperation[];
    transform(other: TextOperation): TextOperation[];
}
